/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define BUFFER_STD_SIZE	65536

class Buffer
{
	protected:
		char		*buffer;
		unsigned int	writePtr;
		unsigned int	readPtr;
		unsigned int	size;
		unsigned int	full;

	public:
		Buffer();

		Buffer(unsigned int sz);

		~Buffer();

		Buffer		*copyBuffer();

		int		add(char *src, unsigned int len);

		int		skip(unsigned int len);

		int		rewind(unsigned int len);

		void		reset();

		int		resize(unsigned int newLen);

		int		bufSuck(char *buf, unsigned int range);

		int		bufPeek(char *buf, unsigned int range);
		
		int		bufSend(Socket *sock);

//		int		bufWrite(int fd);

		int		bufFWrite(FILE *f);

		int		bufRecv(Socket *sock);

//		int		bufRead(int fd);

		int		bufFRead(FILE *f);

		unsigned int	bytesEmpty();

		unsigned int	bytesInBuffer();

		unsigned int	getSize();

		/*
		 * FAME
		 */

		// bufSuckp malloc's a new char [] of length range, return 0 otherwise
		char		*bufSuckp(unsigned int range);
};