/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class CacheEntry : public DBElement
{
	private:
		char		pattern[FILE_NAME_LENGTH];
		Packet		*response;
		int		numStrings;
		void		sortPattern();

	public:
		CacheEntry(char *newPattern, int newNumStrings);

		CacheEntry(char *newPattern, Packet *newResponse, int newNumStrings);

		~CacheEntry();

		void		setResponse(Packet *newResponse);

		int		getNumStrings();

		/*
		 * FAME
		 */
		char		*getPatternp();

		Packet		*getResponsep();

		/*
		 * DBElement inheritance
		 */
                int		equals(DBElement *object);

                int		lessThan(DBElement *object);

                int 		greaterThan(DBElement *object);

		unsigned int	hashValue();

};