/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define	COMMAND_HOST		0
#define	COMMAND_SET		1
#define	COMMAND_HELP		2
#define	COMMAND_SEARCH		3
#define	COMMAND_LIST		4
#define	COMMAND_DOWNLOAD	5
#define	COMMAND_KILL		6
#define	COMMAND_SHARE		7
#define	COMMAND_SCAN		8
#define	COMMAND_SAVE		9
#define COMMAND_VERSION		10
#define COMMAND_HOLDON		11 // THIS IMPLEMENTS A WARNING TO SPELL OUT 'HOLDON'
#define COMMAND_QUIT		12
#define COMMAND_INVALID		99

#define STATE_NAME_LENGTH       30
#define	COMMAND_BUF_SIZE	250

class Commander
{
	protected:
		ControlCentre	*MCC;
		int		running;
		char		prevCommand[COMMAND_BUF_SIZE];
		char		prevListCommand[COMMAND_BUF_SIZE];
		int		os;
		int		interpCommand(char *buf);

		int		doHost(char *buf, Backend *b, char *outbuf);

		int		doSet(char *buf, Backend *b, char *outbuf);

		int		doHelp(char *buf, Backend *b, char *outbuf);

		int		doSearch(char *buf, Backend *b, char *outbuf);

		int		doList(char *buf, Backend *b, char *outbuf);

		int		doDownload(char *buf, Backend *b, char *outbuf);

		int		doKill(char *buf, Backend *b, char *outbuf);
	 
		int		doShare(char *buf, Backend *b, char *outbuf);
	 
		int		doScan(char *buf, Backend *b, char *outbuf);
	 
		int		doSave(char *buf, Backend *b, char *outbuf);
	 
		int		doVersion(char *buf, Backend *b, char *outbuf);
	
		int		doHoldon(char *buf, Backend *b, char *outbuf);
	
		int		doQuit(char *buf, Backend *b, char *outbuf);

/*
		int		do(char *buf, Backend *b, char *outbuf);
	
*/
		void		getStateName(int st, char *buf);

		void		mkPrintable(char *buf);

	public	:
		Commander(ControlCentre *newMCC);
		
		int	doCommand(char *buf, Backend *b, char *outbuf);
		
		int	keepRunning();
};
