/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Constants.h"
#include "ControlCentre.h"

ControlCentre::ControlCentre()
{
	int	i;

	MAX_TTL			= DEFAULT_MAX_TTL;
	DEFAULT_TTL             = DEFAULT_DEFAULT_TTL;
	MAX_CONNECTIONS         = DEFAULT_MAX_CONNECTIONS;
	ROUTING_TABLE_SIZE      = DEFAULT_ROUTING_TABLE_SIZE;
	PORT                    = DEFAULT_PORT;
	SPEED			= DEFAULT_SPEED;
	MAX_HOPS                = DEFAULT_MAX_HOPS;
	MAX_HOSTS		= DEFAULT_MAX_HOSTS;
	MAX_HOST_CON_FAIL	= DEFAULT_MAX_HOST_CON_FAIL;
	MAX_UPLOADS             = DEFAULT_MAX_UPLOADS;
	MAX_DOWNLOADS           = DEFAULT_MAX_DOWNLOADS;
	MAX_RESULTS             = DEFAULT_MAX_RESULTS;
	MAX_FILES_SHARED	= DEFAULT_MAX_FILES_SHARED;
	MAX_CON_ERRORS		= DEFAULT_MAX_CON_ERRORS;
	MAX_PUSH_REQUESTS       = DEFAULT_MAX_DOWNLOADS; // THIS IS NOT A BUG
	MAX_MONITOR_LENGTH	= DEFAULT_MAX_MONITOR_LENGTH;
	AUTO_PUSH		= DEFAULT_AUTO_PUSH;
	AUTO_CONNECTIONS	= DEFAULT_AUTO_CONNECTIONS;
	AUTO_CLEAR_COMPLETE	= DEFAULT_AUTO_CLEAR_COMPLETE;
	AUTO_CLEAR_RESULTS	= DEFAULT_AUTO_CLEAR_RESULTS;
	AUTO_SAVE_HOSTS		= DEFAULT_AUTO_SAVE_HOSTS;
	IGNORE_LOCAL_IP		= DEFAULT_IGNORE_LOCAL_IP;
	NOTIFY_RESULTS		= DEFAULT_NOTIFY_RESULTS;
	CACHE_ENTRIES		= DEFAULT_CACHE_ENTRIES;
	PACKET_RATIO		= DEFAULT_PACKET_RATIO;
	errorBuf[0]		= 0;
	errorWriter		= &errorBuf[0];
	notifyResults		= 0;

	for (i = 0; i < CLIENTID_LENGTH; i++)
		CLIENTID[i]	= 0;

	strcpy(DOWNLOAD_DIR, getenv("HOME"));

#ifdef DAEMON
	DAEMON_PORT		= 1414;
#endif
}

int ControlCentre::get_MAX_MONITOR_LENGTH()
{
	return MAX_MONITOR_LENGTH;
}

int ControlCentre::get_PORT()
{
	return PORT;
}

int ControlCentre::get_AUTO_SAVE_HOSTS()
{
	return AUTO_SAVE_HOSTS;
}

int ControlCentre::get_AUTO_PUSH()
{
	return AUTO_PUSH;
}

int ControlCentre::get_AUTO_CONNECTIONS()
{
	return AUTO_CONNECTIONS;
}

int ControlCentre::get_AUTO_CLEAR_COMPLETE()
{
	return AUTO_CLEAR_COMPLETE;
}

int ControlCentre::get_AUTO_CLEAR_RESULTS()
{
	return AUTO_CLEAR_RESULTS;
}

int ControlCentre::get_SPEED()
{
	return SPEED;
}

int ControlCentre::get_MAX_PUSH_REQUESTS()
{
	return MAX_PUSH_REQUESTS;
}

#ifdef DAEMON
int ControlCentre::get_DAEMON_PORT()
{
	return DAEMON_PORT;
}
#endif

int ControlCentre::get_MAX_RESULTS()
{
	return MAX_RESULTS;
}

int ControlCentre::get_MAX_TTL()
{
        return MAX_TTL;
}

int ControlCentre::get_DEFAULT_TTL()
{
	if (MAX_TTL >= DEFAULT_TTL)
		return DEFAULT_TTL;
	else
		return MAX_TTL;
}

int ControlCentre::get_ROUTING_TABLE_SIZE()
{
	return ROUTING_TABLE_SIZE;
}

int ControlCentre::get_MAX_CONNECTIONS()
{
        return MAX_CONNECTIONS;
}

int ControlCentre::get_MAX_HOPS()
{
	return MAX_HOPS;
}

int ControlCentre::get_MAX_HOSTS()
{
	return MAX_HOSTS;
}

int ControlCentre::get_MAX_HOST_CON_FAIL()
{
	return MAX_HOST_CON_FAIL;
}

int ControlCentre::get_MAX_UPLOADS()
{
	return MAX_UPLOADS;
}

int ControlCentre::get_MAX_DOWNLOADS()
{
	return MAX_DOWNLOADS;
}

int ControlCentre::get_MAX_FILES_SHARED()
{
	return MAX_FILES_SHARED;
}

int ControlCentre::get_MAX_CON_ERRORS()
{
	return MAX_CON_ERRORS;
}

int ControlCentre::get_IGNORE_LOCAL_IP()
{
	return IGNORE_LOCAL_IP;
}

int ControlCentre::get_NOTIFY_RESULTS()
{
	return NOTIFY_RESULTS;
}

int ControlCentre::get_CACHE_ENTRIES()
{
	return CACHE_ENTRIES;
}

int ControlCentre::get_PACKET_RATIO()
{
	return PACKET_RATIO;
}

void ControlCentre::get_CLIENTID(char *buf)
{
	memcpy(buf, CLIENTID, CLIENTID_LENGTH);
}

void ControlCentre::get_DOWNLOAD_DIR(char *buf)
{
	memcpy(buf, DOWNLOAD_DIR, FILE_NAME_LENGTH);
}

void ControlCentre::set_MAX_TTL(int newTTL)
{
	MAX_TTL = newTTL;
}

void ControlCentre::set_AUTO_SAVE_HOSTS(int sh)
{
	AUTO_SAVE_HOSTS	= sh;
}

void ControlCentre::set_DEFAULT_TTL(int newDTTL)
{
	DEFAULT_TTL	= newDTTL;
}

void ControlCentre::set_ROUTING_TABLE_SIZE(int newSize)
{
	ROUTING_TABLE_SIZE	= newSize;
}

void ControlCentre::set_MAX_CONNECTIONS(int newMC)
{
	MAX_CONNECTIONS		= newMC;
}

void ControlCentre::set_MAX_HOPS(int newHops)
{
	MAX_HOPS	= newHops;
}

void ControlCentre::set_MAX_HOSTS(int newHosts)
{
	MAX_HOSTS	= newHosts;
}

void ControlCentre::set_MAX_HOST_CON_FAIL(int newTries)
{
	MAX_HOST_CON_FAIL	= newTries;
}

void ControlCentre::set_MAX_UPLOADS(int newUploads)
{
	MAX_UPLOADS	= newUploads;
}

void ControlCentre::set_MAX_DOWNLOADS(int newDownloads)
{
	MAX_DOWNLOADS	= newDownloads;
}

void ControlCentre::set_MAX_RESULTS(int newResults)
{
	MAX_RESULTS	= newResults;
}

void ControlCentre::set_PORT(int newPort)
{
	PORT		= newPort;
}

void ControlCentre::set_AUTO_PUSH(int i)
{
	AUTO_PUSH	= i;
}

void ControlCentre::set_AUTO_CLEAR_COMPLETE(int i)
{
	AUTO_CLEAR_COMPLETE	= i;
}

void ControlCentre::set_AUTO_CLEAR_RESULTS(int i)
{
	AUTO_CLEAR_RESULTS	= i;
}

void ControlCentre::set_AUTO_CONNECTIONS(int i)
{
	AUTO_CONNECTIONS	= i;
}

void ControlCentre::set_SPEED(int newSpeed)
{
	SPEED		= newSpeed;
}

void ControlCentre::set_MAX_PUSH_REQUESTS(int newMPR)
{
	MAX_PUSH_REQUESTS	= newMPR;
}

#ifdef DAEMON
void ControlCentre::set_DAEMON_PORT(int newDP)
{
	DAEMON_PORT		= newDP;
}
#endif

void ControlCentre::set_MAX_FILES_SHARED(int i)
{
	if (i <= FS_MAX)
		MAX_FILES_SHARED	= i;
	else
		MAX_FILES_SHARED	= FS_MAX;
}

void ControlCentre::set_MAX_CON_ERRORS(int i)
{
	MAX_CON_ERRORS		= i;
}

void ControlCentre::set_IGNORE_LOCAL_IP(int i)
{
	IGNORE_LOCAL_IP	= i;
}

void ControlCentre::set_NOTIFY_RESULTS(int i)
{
	NOTIFY_RESULTS	= i;
}

void ControlCentre::set_CACHE_ENTRIES(int i)
{
	if (i <= 0)
		CACHE_ENTRIES	= 1;
	else
		if (i > 100000)
			CACHE_ENTRIES	= 100000;
		else
			CACHE_ENTRIES	= i;	
}

void ControlCentre::set_PACKET_RATIO(int i)
{
	PACKET_RATIO	= i;
}

void ControlCentre::set_CLIENTID(char *buf)
{
	memcpy(CLIENTID, buf, CLIENTID_LENGTH);
}

void ControlCentre::set_DOWNLOAD_DIR(char *buf)
{
	if ((buf[0] == '~') && (buf[1] == '/'))
		sprintf(DOWNLOAD_DIR, "%s/%s", getenv("HOME"), buf + 2);
	else
		strcpy(DOWNLOAD_DIR, buf);
}

void ControlCentre::set_MAX_MONITOR_LENGTH(int ml)
{
	MAX_MONITOR_LENGTH	= ml;
}

void ControlCentre::addError(char *buf)
{
	unsigned int	len;

	len		= strlen("Error : ") + strlen(buf) + strlen ("\r\n");
	if ( len > (ERROR_LENGTH - (errorWriter - errorBuf) + strlen("\r\n") + 1) )
		return;
	sprintf(errorWriter, "Error : %s\r\n", buf);
	errorWriter	+= len;
}

void ControlCentre::clearError()
{
	errorBuf[0]	= 0;
	errorWriter	= &errorBuf[0];
}

void ControlCentre::setNotifyResults()
{
	notifyResults	= 1;
}

int ControlCentre::getNotifyResults()
{
	return notifyResults;
}

void ControlCentre::clearNotifyResults()
{
	notifyResults	= 0;
}

/*
 * What a dirty trick! (Well, I just call it 'FAME' as of version > 0.9.1)
 */
char *ControlCentre::getError()
{
	return (char *)errorBuf;
}

char *ControlCentre::get_CLIENTIDp()
{
	return (char *)CLIENTID;
}
