/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define	DEFAULT_MAX_TTL			7
#define	DEFAULT_DEFAULT_TTL		7
#define	DEFAULT_ROUTING_TABLE_SIZE	40000
#define	DEFAULT_PORT			6346
#define	DEFAULT_SPEED			56
#define	DEFAULT_MAX_CONNECTIONS		50
#define	DEFAULT_MAX_RESULTS		1000
#define	DEFAULT_MAX_HOPS		7
#define DEFAULT_MAX_UPLOADS		3
#define	DEFAULT_MAX_DOWNLOADS		50
#define	DEFAULT_MAX_PUSH_REQUESTS	DEFAULT_MAX_DOWNLOADS
#define	DEFAULT_MAX_HOSTS		20000
#define	DEFAULT_MAX_MONITOR_LENGTH	20
#define	DEFAULT_MAX_HOST_CON_FAIL	1
#define	DEFAULT_MAX_FILES_SHARED	FS_MAX
#define	DEFAULT_MAX_CON_ERRORS		500000
#define	DEFAULT_AUTO_CLEAR_COMPLETE	1
#define	DEFAULT_AUTO_CONNECTIONS	4
#define	DEFAULT_AUTO_PUSH		1
#define	DEFAULT_AUTO_CLEAR_RESULTS	1
#define	DEFAULT_AUTO_SAVE_HOSTS		1
#define	DEFAULT_IGNORE_LOCAL_IP		1
#define	DEFAULT_NOTIFY_RESULTS		1
#define DEFAULT_CACHE_ENTRIES		2000
#define	DEFAULT_DAEMON_PORT		1414
#define DEFAULT_PACKET_RATIO		30

//#define DEFAULT_
//#define DEFAULT_

class ControlCentre
{
	private :
		int 	MAX_TTL;
		int	DEFAULT_TTL;
		int	ROUTING_TABLE_SIZE;
		int	PORT;
		int	SPEED;
		int	MAX_CONNECTIONS;
		int	MAX_RESULTS;
		int	MAX_HOPS;
		int	MAX_PUSH_REQUESTS;
		int	MAX_UPLOADS;
		int	MAX_DOWNLOADS;
		int	MAX_HOSTS;
		int	MAX_MONITOR_LENGTH;
		int	MAX_HOST_CON_FAIL;
		int	MAX_FILES_SHARED;
		int	MAX_CON_ERRORS;
		int	AUTO_CLEAR_COMPLETE;
		int	AUTO_CONNECTIONS;
		int	AUTO_PUSH;
		int	AUTO_CLEAR_RESULTS;
		int	AUTO_SAVE_HOSTS;
		int	IGNORE_LOCAL_IP;
		int	NOTIFY_RESULTS;
		int	CACHE_ENTRIES;
		int	PACKET_RATIO;
		char	CLIENTID[CLIENTID_LENGTH];
		char	DOWNLOAD_DIR[FILE_NAME_LENGTH];
#ifdef DAEMON
		int	DAEMON_PORT;
#endif
		char	errorBuf[ERROR_LENGTH];
		char	*errorWriter;
		int	notifyResults;

	public :

		ControlCentre ();

		int 	get_MAX_TTL();

		int 	get_DEFAULT_TTL();

		int 	get_ROUTING_TABLE_SIZE();

                int 	get_PORT();

                int 	get_SPEED();

                int 	get_MAX_CONNECTIONS();

                int 	get_MAX_RESULTS();

                int 	get_MAX_HOPS();

                int 	get_MAX_HOST_CON_FAIL();

                int 	get_MAX_PUSH_REQUESTS();

                int 	get_MAX_UPLOADS();

                int 	get_MAX_DOWNLOADS();

		int	get_MAX_MONITOR_LENGTH();

                int 	get_MAX_HOSTS();

                int	get_MAX_FILES_SHARED();

                int	get_MAX_CON_ERRORS();

		int	get_AUTO_PUSH();

		int	get_AUTO_CLEAR_COMPLETE();

		int	get_AUTO_CLEAR_RESULTS();

		int	get_AUTO_CONNECTIONS();

		int	get_AUTO_SAVE_HOSTS();

		int	get_IGNORE_LOCAL_IP();

		int	get_NOTIFY_RESULTS();

		int	get_CACHE_ENTRIES();

		int	get_PACKET_RATIO();

#ifdef DAEMON
		int 	get_DAEMON_PORT();
#endif
		void	get_CLIENTID(char *buf);

		void	get_DOWNLOAD_DIR(char *buf);

	 	/*
		 * Set funcs here
		 */

		void 	set_MAX_TTL(int newTTL);

		void 	set_DEFAULT_TTL(int newDTTL);

                void 	set_MAX_CONNECTIONS(int newMC);

		void 	set_ROUTING_TABLE_SIZE(int newSize);

                void 	set_MAX_HOPS(int newHops);

                void 	set_MAX_HOSTS(int newHosts);

                void 	set_MAX_HOST_CON_FAIL(int newTries);

                void 	set_MAX_UPLOADS(int newUploads);

                void 	set_MAX_DOWNLOADS(int newDownloads);

                void 	set_MAX_RESULTS(int newResults);

		void 	set_PORT(int newPort);

		void 	set_SPEED(int newSpeed);

		void 	set_MAX_PUSH_REQUESTS(int newMPR);

		void	set_AUTO_SAVE_HOSTS(int sh);

#ifdef DAEMON
		void	set_DAEMON_PORT(int newDP);
#endif
		void	set_CLIENTID(char *buf);

		void	set_DOWNLOAD_DIR(char *buf);

		void	set_MAX_MONITOR_LENGTH(int ml);

		void	set_AUTO_PUSH(int i);

		void	set_AUTO_CLEAR_COMPLETE(int i);

		void	set_AUTO_CLEAR_RESULTS(int i);

		void	set_AUTO_CONNECTIONS(int i);

                void	set_MAX_FILES_SHARED(int i);

                void	set_MAX_CON_ERRORS(int i);

		void	set_IGNORE_LOCAL_IP(int i);

		void	set_NOTIFY_RESULTS(int i);

		void	set_CACHE_ENTRIES(int i);

		void	set_PACKET_RATIO(int i);

		/*
		 * Service to users
		 */
		void	addError(char *buf);

		void	clearError();

		void	setNotifyResults();

		int	getNotifyResults();

		void	clearNotifyResults();

		/*
		 * FAME
		 */
		char	*getError();

		char	*get_CLIENTIDp();
};
