/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define HASH_TINY	67
#define	HASH_SMALL	211
#define HASH_MEDIUM	15679
#define HASH_LARGE	65537
#define HASH_HUGE	127979

#define DEFAULT_HASH_SIZE HASH_MEDIUM

class DB
{
	private:
		DBElement		**myDBHash;
		DBElement		**myDB;
		int			DBSize;
		int			elements;
		int			last;
		int			hashSpace;
		int			oldest;
		int			youngest;
		DBElement		*mklist(DBElement *tree);
		void 			insertSortedList(DBElement *list,
						int len, int hash);
		void			insertSortedElement(DBElement *el,
						int hash);

	public:
		DB(int size);

		DB(int size, int hashSpace);

		~DB();

		void 		clearDB();

		DBElement 	*findElement(int index);

		/*
		 * returns the corresponding index or ENTRY_INVALID
		 */
		int 		containsElement(DBElement *el);

		/*
		 * returns true on success
		 */
		int 		storeElement(DBElement *el);

		/*
		 * delete the entry from the DB and from memory
		 */
		int 		deleteElement(int index);

		/*
		 * delete the entry from the DB but not from memory
		 */
		int		removeElement(int index);

		int 		isFull();

		int 		containsElementAtIndex(int i);

		int 		getSize();

		int 		getElements();

		int		getOldest();

		int		getYoungest();

		/*
		 * return true on success, false if element
		 * not found. Marks entry as 'youngest'.
		 */
		int		touch(int index);

		int 		integrity();

		void		balance();
};
