/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * This Class is supposed to be abstract.
 */

#define	ENTRY_INVALID	-1
#define NO_PARENT	-1
#define PARENT_INVALID	-2
 
class DBElement
{
	protected:
		DBElement	*left;
		DBElement	*right;
		int		entry;
		int		parent;
		int		younger;
		int		older;

	public:
		DBElement();

		DBElement(int newEntry, int newParent);

		DBElement(int newEntry, int newParent, int newYounger, int newOlder);

		DBElement 	*getLeft();

		DBElement 	*getRight();

		int 		getEntry();

		int 		getParent();

		int		getOlder();

		int		getYounger();

		void 		setLeft(DBElement *newLeft);

		void 		setRight(DBElement *newRight);

		void 		setEntry(int newEntry);

		void 		setParent(int newParent);

		void		setOlder(int newOlder);

		void		setYounger(int newYounger);

		/*
		 * These Functions should be overloaded
		 */

                virtual int 	equals(DBElement *object) = 0;

                virtual int 	lessThan(DBElement *object) = 0;

                virtual int 	greaterThan(DBElement *object) = 0;

		/*
		 * hashValue should alwyas generate the same value for
		 * given object!
		 */
		virtual unsigned int	hashValue() = 0;

		virtual ~DBElement() {};
};
