/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define DL_MAX_CON	15

#define CON_STATE_PENDING	100

class Download : public Transfer
{
	private:
		char		cid[CLIENTID_LENGTH];
		time_t		waitSecs;
		int		resultConnection;

	public	:
		Download(int newFileID, char *newFileName,
				char *newDirName, int newOffset, char *newCID);

		Download(Connection *c, int newFileID, char *newFileName,
				char *newDirName, int newOffset, char *newCID);

		Download(Connection *c);

		void	reInit(int newFileID, char *newFileName, char *newDirName,
				char *newCID);

		/*
		 * LoginToPeer return values :
		 * 1 	: OK
		 * 0	: Unable to send login
		 */
		int 	loginToPeer();

		/*
		 * WaitResponse return values :
		 * 1	: OK
		 * -1	: Peer doesn't respond with HTTP 200 OK
		 * -2	: Unable to parse HTTP header
		 * -3	: Unable to remove HTTP header
		 */
		int	waitResponse();

		int 	readBlob();

		void	getCID(char *buf);

		int	getResultConnection();

		time_t	getWaitSecs();

		void	setWaitSecs(time_t t);

		void	setResultConnection(int i);

		/*
		 * FAME
		 */

		char	*getCIDp();
};

