/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define SECS_UNTIL_RETRY	20

class Downloader : public HTTPClient
{
	private	:
		ControlCentre	*MCC;
		DB		*downloads;
		DB		*pushRequests;
		int		clearComplete();
		int		handlePendingPush(Download *c);
		unsigned int	bytesDownloaded;

	public	:
		Downloader(ControlCentre *newMCC);

		~Downloader();

		int		pollDownloader();

		int		startDownload(unsigned long int netOrderIP,
					int port, int id, char *fn, char *cid,
					int rescon);

		int		continueDownload(unsigned long int netOrderIP,
					int port, int id, char *fn, char *cid,
					int rescon);

		int 		killDownload(int i);

		int		newPushRequest(int fid, char *fn, 
					char *mid, char *cid, int os);

		int		handlePush(Connection *c);

		int		resize();

		int		isUsingHost(int hi);

		TransferStatus 	*getStatusList();
		
		DB		*getDownloads();

		/*
		 * Stats
		 */
		unsigned int	getBytesDownloaded();
};
