/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * This class can :
 *	-Start listening
 *	-Stop listening
 *	-Open a connection (push)
 *	-poll all connections
 */

#define SEARCH_ARRAY_SIZE	( (BASE * BASE * BASE) + (BASE * BASE) + BASE )
#define HASH_ARRAY_SIZE		50033

#define	UIBITS	(8 * sizeof(unsigned int))

#define SETBIT(X,Y)	 X[((Y) / UIBITS)]	= \
				(X[((Y) / UIBITS)] | BITS[((Y) % UIBITS)])
				
#define ISSET(X,Y)	(X[((Y) / UIBITS)] & BITS[((Y) % UIBITS)])

#define INDEXOF(X)	(strchr(vc, X) - vc + 1)

/*
 * Change the value of 'base' when the number of 'validchars' are changed
 */
#define BASE		37
#define VAL1(X)		INDEXOF(X)
#define VAL2(X,Y)	((BASE * INDEXOF(X)) + INDEXOF(Y))
#define VAL3(X,Y,Z)	((BASE * BASE * INDEXOF(X)) 		+ \
				(BASE * INDEXOF(Y))	+ INDEXOF(Z))

class FServer : public HTTPServer, public FSScanner
{
	private	:
		DB		*uploads;
		DB		*files;
		DB		*cache;
		Path		*paths;
		ControlCentre	*MCC;
		char		vc[BASE];
		unsigned int	*searchArray[SEARCH_ARRAY_SIZE];
		unsigned int	*hashArray[HASH_ARRAY_SIZE];
		unsigned int	hashCRC[HASH_ARRAY_SIZE];
		unsigned int	searchCRC[SEARCH_ARRAY_SIZE];
		unsigned int	hashCount[HASH_ARRAY_SIZE];
		unsigned int	searchCount[SEARCH_ARRAY_SIZE];
		unsigned int	sizeShared;
		unsigned int	localSearches;
		unsigned int	cacheHits;
		unsigned int	BITS[UIBITS];
		
		/*
		 * search/hash ArraySize refers to total size in memory
		 */
		unsigned int	searchArraySize;
		unsigned int	hashArraySize;
		
		int		handleUploads();
		
		/*
		 * `range', the number of ints ANDed, must be at least 1
		 */
		unsigned int	*ANDSearch(unsigned int *result, unsigned int *model,
						unsigned int range);
		int		addToSearchArray(char *fn, int idx);
		int		addToHashArray(char *fn, int idx);
		unsigned int 	*searchSearchArray(char *findme,
						unsigned int *searchBits);
		unsigned int 	*searchHashArray(char *findme,
						unsigned int *searchBits);
		unsigned int	crc(unsigned int *array, int range);
		int 		checkCRC();
		
		/*
		 * Returns number of sub Strings
		 */
		int		preparePattern(char *buf);
		LocalResult 	*mkLocalResultList(unsigned int *searchBits,
							char *findme);
		unsigned int	hashStr(char *buf, unsigned int prime);


	public	:
		FServer(ControlCentre *newMCC);
		
		~FServer();

		int		addUpload(Connection *c);

		int 		push(int fileID, unsigned int hostip,
					unsigned short hostport);

		int 		pollFServer();

		int 		killUpload(int i);

		int 		addPath(char *newPath);

		int 		deletePath(char *oldPath);

		int 		delAllPath();

		Path 		*getPaths();

		int 		doScan();

		unsigned int	getFilesCount();

		unsigned int	getSizeShared();

		int		isUsingHost(int hi);

		int		resize();

		int		resizeCache();

		TransferStatus 	*getStatusList();

		Packet		*mkSearchResp(char *findme);

		unsigned int	getLocalSearches();

		unsigned int	getCacheHits();

		unsigned int	getCacheEntries();

		unsigned int	getCacheSize();

		unsigned int	getSearchArraySize();

		unsigned int	getHashArraySize();
		
		int		integrity();
};
