/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * This is a PORT specific class
 */
 
#define FILE_SIZE_UNKNOWN	-1

class File : public FSEntry
{
	private	:
		int		size;
		char		fileName[FILE_NAME_LENGTH];
		char		preparedFn[FILE_NAME_LENGTH];
		Path		*FPath;

	public :
		File(int s, char *fn, Path *newFPath);

		void 		setSize(int s);

		int		getSize();

		void 		getFileName(char *buf);

		void 		setFileName(char *buf);

		void 		getPreparedFn(char *buf);

		Path 		*getPath();

		void 		setPath(Path *newFPath);
		
		/*
		 * Determine properties of the file, i.e. the size.
		 */
		int		statFile();

		/*
		 * FAME
		 */

		char		*getFileNamep();

		char		*getPreparedFnp();

		/*
		 * DBElement inheritance
		 */

		int		equals(DBElement *myFile);

		int		lessThan(DBElement *myFile);

		int		greaterThan(DBElement *myFile);

		unsigned int	hashValue();
};

