/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class GnutellaRouter
{
	private :
		ControlCentre	*MCC;
		DB		*messages;
		unsigned int	initPackets;
		unsigned int	initRespPackets;
		unsigned int	pushPackets;
		unsigned int	searchPackets;
		unsigned int	searchRespPackets;
		unsigned int	respMatches;
		unsigned int	respMisses;
		unsigned int	doublePackets;

		void handle_init(GnutellaPacket *pkt, DB *connections);

		void handle_init_resp(GnutellaPacket *pkt, DB *connections);

		void handle_push(GnutellaPacket *pkt, DB *connections);

		void handle_search(GnutellaPacket *pkt, DB *connections);

		void handle_search_resp(GnutellaPacket *pkt, DB *connections);

		void handle_odd(GnutellaPacket *pkt, DB *connections);

		void handle_even(GnutellaPacket *pkt, DB *connections);

/*
		void handle_(GnutellaPacket *pkt, DB *connections,
						DB *hosts);
*/

	public :
		GnutellaRouter(ControlCentre   *newMCC);

		~GnutellaRouter();

		int	resize();

		void 	handle(GnutellaPacket *pkt, DB *connections);

		int 	broadcast(GnutellaPacket *pkt, DB *connections);

		int	sendPacket(GnutellaPacket *pkt, DB *connections);

		int 	alreadySeen(Mesg *m);

		/*
		 * Stats
		 */

		unsigned int	getInitPackets();

		unsigned int	getInitRespPackets();

		unsigned int	getPushPackets();

		unsigned int	getSearchPackets();

		unsigned int	getSearchRespPackets();

		unsigned int	getRespMatches();

		unsigned int	getRespMisses();

		unsigned int	getDoublePackets();

};
