/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * System dependent includes
 */
#if ( (OS == LINUX) || (OS == FREEBSD) )
#include <sys/types.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdio.h>
#endif

/*
 * Other includes
 */
#include "Config.h"
#include "Constants.h"
#include "DBElement.h"
#include "Socket.h"
#include "Buffer.h"
#include "Connection.h"
#include "Transfer.h"
#include "Download.h"
#include "HTTPClient.h"

HTTPClient::HTTPClient()
{
}


Download *HTTPClient::getFile(unsigned long int netOrderIP, int port,
					int id, char *fileName, char *cid, char *path)
{
	Download	*d;
	int		offset;
	
	offset	= fileLength(path, fileName);

  	d	= new Download(id, fileName, path, offset, cid);
	d->setType(CON_TYPE_DOWNLOAD);
	d->Connect(netOrderIP, (unsigned short)port);
	d->tryToConnect();
	
	return d;
}

/*
 * System dependent implementation
 */
 
#if ( (OS == LINUX) || (OS == FREEBSD) )
int HTTPClient::fileLength(char *path, char *fileName)
{
	struct	stat	statData;
	char		fn[2 * FILE_NAME_LENGTH];
	
	sprintf(fn, "%s/%s", path, fileName);
	fn[FILE_NAME_LENGTH - 1]	= 0;
	if (stat(fn, &statData) == -1)
		return 0;

	return statData.st_size;
}
#endif
