/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define SEND404(X)	(X)->sendStr("HTTP 404\r\nDocument not found.\r\n\r\n", \
                                strlen("HTTP 404\r\nDocument not found.\r\n\r\n"))

#define SEND401(X)	(X)->sendStr("HTTP 401\r\nNot Authorised.\r\n\r\n", \
						strlen("HTTP 401\r\nNot Authorised.\r\n\r\n"))

#define SEND503(X)	(X)->sendStr("HTTP 503\r\nMaximum number of downloads exceeded.\r\n\r\n", \
  	                      strlen("HTTP 503\r\nMaximum number of downloads exceeded.\r\n\r\n"))

class HTTPServer
{
	private:
		/*
		 * returns true when read from s is successfull
		 */
		int	readRequest(Connection *c, int *fileID, char *fileName, int *offset);

		/*
		 * Send mime header or something appropriate
		 */
		int	sendHeader(Upload *u, File *f);

	public:
		HTTPServer();

		/*
		 * c must be considered deleted after a call to serve.
		 * On success, a new Upload is returned.
		 * On error, NULL is returned.
		 */
		Upload	*serve(Connection *c, DB *files);
};
