/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * This is a PORT-specific class!
 * All methods should return 0 on faillure, true on success.
 */
 
class Inet
{
	public:
		/*
		 * Translates a string from "1.2.3.4" to an IP address in
		 * NETWORK byte order.
		 */
		static unsigned long int	dottedToIP(char *dotted);
		
		/*
		 * places ip and port in buf is the following notation :
		 * 1.2.3.4:5
		 */ 
		static int			IPPortToDotted(char *buf,
								unsigned long int netIP,
								unsigned short port);

		/*
		 * places ip and port in buf is the following notation :
		 * 1.2.3.4
		 */ 
		static int			IPToDotted(char *buf,
								unsigned long int netIP);

		/*
		 * Returns the ip address for hostname
		 */
		static unsigned long int	NSLookup(char *hostname);

		/*
		 * Put hostname in host
		 */
		static int			getHostName(char *host, int hlen);
};
