/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ctype.h>
#include <string.h>

#include "Constants.h"
#include "DBElement.h"
#include "FSEntry.h"
#include "Path.h"
#include "File.h"
#include "LocalResult.h"

LocalResult::LocalResult(File *newLRFile)
{
	unsigned int	i;
	unsigned int	j;

	LRFile	= newLRFile;
	LRFile->getFileName(fn);
	j	= 0;
	for (i = 0; i < strlen(fn); ++i)
	{
		char	c;

		c	= toupper(fn[i]);
		if (strchr(VALIDCHARS, c))
			fn[i + j]	= c;
		else
			j--;
	}
	fn[i + j]	= 0;
	next		= 0;
}

LocalResult::LocalResult(File *newLRFile, LocalResult *newNext)
{
	unsigned int	i;
	unsigned int	j;

	LRFile	= newLRFile;
	LRFile->getFileName(fn);
	j	= 0;
	for (i = 0; i < strlen(fn); ++i)
	{
		char	c;

		c	= toupper(fn[i]);
		if (strchr(VALIDCHARS, c))
			fn[i + j]	= c;
		else
			j--;
	}
	fn[i + j]	= 0;
	next	= newNext;
}

void LocalResult::recDelLocalResult()
{
	if (next)
		next->recDelLocalResult();

	delete this;
}

File *LocalResult::getLRFile()
{
	return LRFile;
}

void LocalResult::setLRFile(File *newLRFile)
{
	unsigned int	i;

	LRFile	= newLRFile;
	LRFile->getFileName(fn);
	for (i = 0; i < strlen(fn); ++i)
		fn[i]	= toupper(fn[i]);
}

LocalResult *LocalResult::getNext()
{
	return next;
}

void LocalResult::setNext(LocalResult *newNext)
{
	next	= newNext;
}

void LocalResult::getFileName(char *buf)
{
	strcpy(buf, fn);
}

/*
 * FAME
 */

char *LocalResult::getFileNamep()
{
	return (char *)fn;
}
