/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include <stdio.h>
#include <string.h>

#include "Constants.h"
#include "DBElement.h"
#include "GnutellaPacket.h"
#include "Mesg.h"

Mesg::Mesg()
{
	sourceConnection	= -1;
	func			= FUNC_INVALID;
}

Mesg::Mesg(GnutellaPacket *pkt)
{
	sourceConnection	= pkt->getSourceConnection();
	func			= pkt->getType();
	pkt->getMesgID((unsigned char *)mesgID);
}

Mesg::Mesg(int newSourceConnection, char newFunc, char *newMesgID)
{
	sourceConnection	= newSourceConnection;
	func			= newFunc;
	memcpy(mesgID, newMesgID, MESSAGE_ID_LENGTH);
}

Mesg::~Mesg()
{
}

int Mesg::getSourceConnection()
{
	return sourceConnection;
}

char Mesg::getFunc()
{
	return func;
}

void Mesg::getMesgID(char *buf)
{
	memcpy(buf, mesgID, MESSAGE_ID_LENGTH);
}

void Mesg::setSourceConnection(int newSourceConnection)
{
	sourceConnection	= newSourceConnection;
}

void Mesg::setFunc(char newFunc)
{
	func	= newFunc;
}

void Mesg::setMesgID(char *src)
{
	memcpy(mesgID, src, MESSAGE_ID_LENGTH);
}

/*
 * DBElement Inheritance
 */

int Mesg::equals(DBElement *myMesg)
{
	return (!strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH));
}

int Mesg::lessThan(DBElement *myMesg)
{
	return (strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH) < 0);
}

int Mesg::greaterThan(DBElement *myMesg)
{
	return (strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH) > 0);
}

unsigned int Mesg::hashValue()
{
	return (*(unsigned int *)mesgID) + (*(unsigned int *)(mesgID + 4) );
}

/*
 * FAME
 */

char *Mesg::getMesgIDp()
{
	return (char *)mesgID;
}

