/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include "Constants.h"
#include "ControlCentre.h"
#include "Query.h"
#include "Monitor.h"

Monitor::Monitor(ControlCentre *newMCC)
{
	MCC		= newMCC;
	top		= 0;
	bottom		= 0;
	length		= 0;
	queryCount	= 0;
}

void Monitor::addQuery(char *query, int speed)
{
	queryCount++;
	top	= new Query(query, speed, top);
	length++;
	if (top->getNext())
		(top->getNext())->setPrev(top);

	if (!bottom)
		bottom	= top;

	if (MCC->get_MAX_MONITOR_LENGTH() < length)
	{
		if (bottom) // this should always be true
		{
			if (bottom->getPrev())
			{
				bottom	= bottom->getPrev();
				bottom->deleteNext();
			}
			else
			{
				bottom->deleteNext();
				bottom	= 0;
			}
			length--;
		}
		else
			MCC->addError("BUG : Monitor : List has no bottom");
	}
}

Query *Monitor::getQueries()
{
	return top;
}

void Monitor::clearQueries()
{
	top->deleteNextRec();
	top	= 0;
	bottom	= 0;
	length	= 0;
}

void Monitor::resize()
{
	if (length <= MCC->get_MAX_MONITOR_LENGTH())
		return;

	while (length > MCC->get_MAX_MONITOR_LENGTH())
	{
		if (!bottom->getPrev())
			break;
		length--;
	}
	if (bottom->getNext())
		bottom->deleteNextRec();
}

unsigned int Monitor::getQueryCount()
{
	return queryCount;
}
