/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/    

#define POLL_HOSTS		10

class Networker
{
	private:
		ControlCentre	*MCC;
		DB		*pendingConnections;
		DB		*pendingPackets;
		Socket		*sock;
		int		listening;
		void		doListen(DB *hosts);
		void		readAllConnections(DB *connections);
		unsigned int	bytesIn;
		unsigned int	bytesOut;
 
	public:
		Networker(ControlCentre *newMCC);

		~Networker();

		/*
		 * Returns 0 or a packet. This function should be called
		 * reguarly.
		 */
		GnutellaPacket 	*waitTraffic(DB *connections);

		int		doSend(DB *connections);

		/*
		 * check for new incoming connections.
		 * This function should be called reguarly
		 */

		Connection	*waitConnection(DB *hosts);

		int 		isListening();

		int 		startListening();

		int 		stopListening();

		int		resize();

		unsigned int	getBytesIn();

		unsigned int	getBytesOut();
};
