/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/    

class Packet : public GnutellaPacket
{
	/*
	 * This class is basically an interface to buildt GnutellaPackets
	 * easily.
	 */
	public:
		Packet(GnutellaPacket *p);

		Packet(unsigned char defaultTTL);

		void	reset(unsigned char defaultTTL);

		/*
		 * mkXXPacket return values :
		 * 1	: OK
		 * 0	: Error
		 */
		int	mkInitPacket(unsigned char defaultTTL);

		int 	mkInitRespPacket(short port, int ip, int count,
					int filesSize, unsigned char defaultTTL);

		int 	mkPushPacket(char *CID, int fix, int ip, short port,
					unsigned char defaultTTL);

		int 	mkSearchPacket(short speed, char *query,
				unsigned char defaultTTL);

		int 	mkSearchRespPacket(char *CID, short port, int ip, 
					int spd, unsigned char defaultTTL);

		int	setSearchRespIP(unsigned int ip);

		/*
		 * add an SRRec to an SearchResponse Packet
		 */
		int 	addToSRPacket(int index, int size, char *name);
};
