/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define PATH_NAME_LENGTH	256

class Path : public FSEntry
{
	private	:
		char	path[PATH_NAME_LENGTH];
		char	subdir;

	public	:
		Path();

		Path(char *newPath);

		Path(char *newPath, char newSubDir);

		void	setPath(char *newPath);

		void 	getPath(char *myPath);

		int	isSubdir();

		void	setSubdir(int sd);

		/*
		 * Generates a list of FSEntries in this directory
		 */
		FSEntry	*list();
		
		/*
		 * FAME
		 */

		char	*getPathp();

		/*
		 * DBElement inheritance
		 */

		int		equals(DBElement *myPath);

		int		lessThan(DBElement *myPath);

		int		greaterThan(DBElement *myPath);

		unsigned int	hashValue();
};

