/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <time.h>
#include <string.h>
#include <unistd.h>

#include "Constants.h"
#include "DBElement.h"
#include "PushRequest.h"

PushRequest::PushRequest()
{
	fileName[0]	=  0;
	offset		=  0;
	issueTime	=  0;
}

PushRequest::PushRequest(char *mid, char *cid)
{
	fileName[0]	=  0;
	offset		=  0;
	issueTime	=  0;
        memcpy(mesgID, mid, MESSAGE_ID_LENGTH);
        memcpy(clientID, cid, CLIENTID_LENGTH);
}

PushRequest::PushRequest(int fid, char *fn, char *mid, char *cid, int os)
{
	strncpy(fileName, fn, FILE_NAME_LENGTH - 2);
	fileName[FILE_NAME_LENGTH -1]	= 0;
	memcpy(mesgID, mid, MESSAGE_ID_LENGTH);
	memcpy(clientID, cid, CLIENTID_LENGTH);
	issueTime			= time(0);
	fileID				= fid;
	offset				= os;
}

time_t PushRequest::getIssueTime()
{
	return issueTime;
}

void PushRequest::getFileName(char *buf)
{
	strncpy(buf, fileName, FILE_NAME_LENGTH - 2);
	buf[FILE_NAME_LENGTH - 1]	= 0;
}

void PushRequest::getMesgID(char *buf)
{
	memcpy(buf, mesgID, MESSAGE_ID_LENGTH);
}

void PushRequest::getClientID(char *buf)
{
	memcpy(buf, clientID, CLIENTID_LENGTH);
}

int PushRequest::getOffset()
{
	return offset;
}

int PushRequest::getFileID()
{
	return fileID;
}

/*
 * DBElement Inheritance
 */

int PushRequest::equals(DBElement *pr)
{
	if (fileID != ((PushRequest *)pr)->getFileID())
		return 0;

	return (!strncmp(fileName, ((PushRequest *)pr)->getFileNamep(),
				FILE_NAME_LENGTH));
}

int PushRequest::lessThan(DBElement *pr)
{
	if (fileID > ((PushRequest *)pr)->getFileID())
		return 0;
	if (fileID < ((PushRequest *)pr)->getFileID())
		return 1;

	return (strncmp(fileName, ((PushRequest *)pr)->getFileNamep(),
				FILE_NAME_LENGTH) < 0);
}

int PushRequest::greaterThan(DBElement *pr)
{
	if (fileID < ((PushRequest *)pr)->getFileID())
		return 0;
	if (fileID > ((PushRequest *)pr)->getFileID())
		return 1;

	return (strncmp(fileName, ((PushRequest *)pr)->getFileNamep(),
				FILE_NAME_LENGTH) > 0);
}

unsigned int PushRequest::hashValue()
{
	return (*(unsigned int *)fileName);
}

/*
 * FAME
 */

char *PushRequest::getFileNamep()
{
	return (char *)fileName;
}

char *PushRequest::getMesgIDp()
{
	return (char *)mesgID;
}

char *PushRequest::getClientIDp()
{
	return (char *)clientID;
}
