/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class PushRequest : public DBElement
{
	protected:
		int	offset;
		int	fileID;
		time_t	issueTime;
		char	fileName[FILE_NAME_LENGTH];
		char	mesgID[MESSAGE_ID_LENGTH];
		char	clientID[CLIENTID_LENGTH];

	public	:
		PushRequest();

		PushRequest(char *mid, char *cid);

		PushRequest(int fid, char *fn, char *mid, char *cid,
				int os);

		int		getFileID();

		time_t		getIssueTime();

		void		getFileName(char *buf);

		void		getMesgID(char *buf);

		void		getClientID(char *buf);

		int		getOffset();

		/*
		 * DBElement inheritance
		 */

		int		equals(DBElement *pr);

		int		lessThan(DBElement *pr);

		int		greaterThan(DBElement *pr);

		unsigned int 	hashValue();

		/*
		 * FAME
		 */

		char		*getFileNamep();

		char		*getMesgIDp();

		char		*getClientIDp();
};
