/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include <string.h>
#include <stdio.h>
#include "Constants.h"
#include "ControlCentre.h"
#include "Query.h"

Query::Query()
{
	query[0]	= 0;
	next		= 0;
	prev		= 0;
}

Query::Query(char *q, int spd)
{
	strncpy(query, q, MAX_SEARCH_LENGTH - 2);
	query[MAX_SEARCH_LENGTH - 1]	= 0;
	speed	= spd;
	prev	= next	= 0;
}

Query::Query(char *q, int spd, Query *newNext)
{
	strncpy(query, q, MAX_SEARCH_LENGTH - 2);
	query[MAX_SEARCH_LENGTH - 1]	= 0;
	speed	= spd;
	next	= newNext;
	prev	= 0;
}

Query *Query::getNext()
{
	return next;
}

Query *Query::getPrev()
{
	return prev;
}

void Query::deleteNext()
{
	if (next)
	{
		delete next;
		next	= 0;
	}
}

void Query::deleteNextRec()
{
	if (next)
	{
		next->deleteNextRec();
		delete next;
		next	= 0;
	}	
}

void Query::setNext(Query *newNext)
{
	next	= newNext;
}

void Query::setPrev(Query *newPrev)
{
	prev	= newPrev;
}

void Query::getQuery(char *buf)
{
	strcpy(buf, query);
}

int Query::getSpeed()
{
	return speed;
}

/*
 * FAME
 */

char *Query::getQueryp()
{
	return (char *)query;
}
