/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <time.h>
#include "DBElement.h"
#include "RCEntry.h"

RCEntry::RCEntry(int newPatternID, int newSourceConnectionID)
{
	patternID		= newPatternID;
	sourceConnectionID	= newSourceConnectionID;
	born			= time(0);
	packetCounter		= COUNTER_ZERO;
	packetID		= -1;
}

int RCEntry::getPatternID()
{
	return patternID;
}

int RCEntry::getPacketID()
{
	return packetID;
}

int RCEntry::getSourceConnectionID()
{
	return sourceConnectionID;
}

int RCEntry::getCounter()
{
	return packetCounter;
}
 
int RCEntry::incCounter()
{
	if (packetCounter == COUNTER_ZERO)
		packetCounter	= 0;

	return ++packetCounter;
}
 
int RCEntry::decCounter()
{
	return --packetCounter;
}
 
time_t RCEntry::getBorn()
{
	return born;
}

void RCEntry::setPacketID(int newPacketID)
{
	packetID	= newPacketID;
}

int RCEntry::equals(DBElement *other)
{
	return ( (patternID == ((RCEntry *)other)->getPatternID())	&&
		 (sourceConnectionID == ((RCEntry *)other)->getSourceConnectionID()) );
}

int RCEntry::lessThan(DBElement *other)
{
	if (patternID < ((RCEntry *)other)->getPatternID())
		return 1;
	if (patternID > ((RCEntry *)other)->getPatternID())
		return 0;

	if (sourceConnectionID < ((RCEntry *)other)->getSourceConnectionID())
		return 1;

	return 0;
}

int RCEntry::greaterThan(DBElement *other)
{
	if (patternID > ((RCEntry *)other)->getPatternID())
		return 1;
	if (patternID < ((RCEntry *)other)->getPatternID())
		return 0;

	if (sourceConnectionID > ((RCEntry *)other)->getSourceConnectionID())
		return 1;

	return 0;
}

unsigned int RCEntry::hashValue()
{
	return (unsigned int)(patternID * sourceConnectionID + patternID);
}


