/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * COUNTER_ZERO is a flag value to indicate that the query has been send but
 * no responses have arrived, which is different than when all results have
 * been flushed and there are zero left.
 */
#define COUNTER_ZERO    -1

/*
 * Source ConnectionID is the ID of the connection that the response came from
 */

class RCEntry : public DBElement
{
	private:
		int	patternID;
		int	sourceConnectionID;
		int	packetCounter;
		int	packetID;
		time_t	born;
 
	public:
                RCEntry(int newPatternID, int newSourceConnectionID);

		/*
		 * The RCEntry should be removed once counter hits 0.
		 */
                int             getCounter();
 
                /*
                 * increases counter and returns its new value;
		 * increase will go directly from COUNTER_ZERO to 1.
                 */
 
                int             incCounter();
 
                /*
                 * decreases counter and returns its new value;
                 */
 
                int             decCounter();
 
		/*
		 * a help during flush()
		 */
		time_t		getBorn();

		int		getPatternID();
		
		int		getPacketID();

		int		getSourceConnectionID();

                void		setPacketID(int newPacketID);
                
                /*
                 * DBElement inheritance
                 */
                int             equals(DBElement *other);
 
                int             lessThan(DBElement *other);
 
                int             greaterThan(DBElement *other);
 
                unsigned int    hashValue();
};
