/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>

#include "DBElement.h"
#include "RCRefList.h"
#include "RCPattern.h"
#include "RCMesgID.h"

RCMesgID::RCMesgID(int newPatternID, char *newMesgID)
{
	memcpy(mesgID, newMesgID, RCMESGID_LENGTH);
	patternID		= newPatternID;
	RCMesgIDMapRefList	= 0;
}

RCMesgID::~RCMesgID()
{
	if (RCMesgIDMapRefList)
	{
		RCMesgIDMapRefList->deleteRest();
		delete RCMesgIDMapRefList;
	}
}

/*
 * Doesn't check for doubles, it should do that.
 */
int RCMesgID::addRCMesgIDMapRef(RCRefList *newRef)
{
	newRef->setNext(RCMesgIDMapRefList);
	RCMesgIDMapRefList	= newRef;
	return 1;
}

RCRefList *RCMesgID::getRCMesgIDMapRefList()
{
	return RCMesgIDMapRefList;
}

int RCMesgID::getPatternID()
{
	return patternID;
}

void RCMesgID::getMesgID(char *buf)
{
	memcpy(buf, mesgID, RCMESGID_LENGTH);
}

char *RCMesgID::getMesgIDp()
{
	return (char *)mesgID;
} 

int RCMesgID::equals(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgID *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] != p[i])
        		return 0;
       	
       	return 1;		
}

int RCMesgID::lessThan(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgID *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] > p[i])
        		return 0;
        	else
			if (mesgID[i] < p[i])
        			return 1;
      
       	return 0;
}

int RCMesgID::greaterThan(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgID *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] < p[i])
        		return 0;
        	else
			if (mesgID[i] > p[i])
        			return 1;
       	
       	return 0;
}

unsigned int RCMesgID::hashValue()
{
	return (unsigned int )(*(unsigned int *)&mesgID);
}
