/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define RCMESGID_LENGTH		16

class RCMesgID : public DBElement
{
	private:
		int		patternID;
		char		mesgID[RCMESGID_LENGTH];
		RCRefList	*RCMesgIDMapRefList;

	public:
		RCMesgID(int newPatternID, char *newMesgID);
		
		~RCMesgID();

		int		getPatternID();

		void		getMesgID(char *buf);

		int		addRCMesgIDMapRef(RCRefList *newRef);
		
		RCRefList	*getRCMesgIDMapRefList();
		
		/*
		 * Fast access
		 */
		char		*getMesgIDp();
 
                /*
                 * DBElement inheritance
                 */
                int             equals(DBElement *other);
 
                int             lessThan(DBElement *other);
 
                int             greaterThan(DBElement *other);
 
                unsigned int    hashValue();
};
