/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "DBElement.h"
#include "RCMesgIDMap.h"
		
RCMesgIDMap::RCMesgIDMap(char *newMesgID, int newMesgIDIndex)
{
	memcpy(mesgID, newMesgID, RCMESGID_LENGTH);
	mesgIDIndex	= newMesgIDIndex;
}

char *RCMesgIDMap::getMesgIDp()
{
	return (char *)mesgID;
}

int RCMesgIDMap::getMesgIDIndex()
{
	return mesgIDIndex;
}

int RCMesgIDMap::equals(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgIDMap *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] != p[i])
        		return 0;
       	
       	return 1;		
}

int RCMesgIDMap::lessThan(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgIDMap *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] > p[i])
        		return 0;
        	else
			if (mesgID[i] < p[i])
        			return 1;
      
       	return 0;
}

int RCMesgIDMap::greaterThan(DBElement *other)
{
	int	i;
	char	*p;
	
        p	= ((RCMesgIDMap *)other)->getMesgIDp();
        for (i = 0; i < RCMESGID_LENGTH; i++)
        	if (mesgID[i] < p[i])
        		return 0;
        	else
			if (mesgID[i] > p[i])
        			return 1;
       	
       	return 0;
}

unsigned int RCMesgIDMap::hashValue()
{
	return (unsigned int )(*(unsigned int *)mesgID + *(unsigned int *)&mesgIDIndex);
}
