/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define PKTID_INVALID		-1

/*
 * possible values for getType()
 */
#define P_INIT			0x00
#define P_INIT_RESPONSE	0x01
#define P_QUERY		0x80
#define P_QUERY_RESPONSE	0x81
#define P_INVALID		-1

class RCPacket
{
	protected:
		void		*packet;
		RCPacket	*next;
		RCPacket	*prv;
		int		packetID;

	public:
		RCPacket(void *newPacket);
		
		virtual ~RCPacket() {};

		int		getType();

		int		getHops();

		void		setHops(int newHops);

		int		getTTL();

		void		setTTL(int newTTL);

		int		getSourceConnectionID();

		int		getTargetConnectionID();

		void		setTargetConnectionID(int newTCID);

		void		getMesgID(char *buf);

		void		*getPacket();

		virtual RCPacket	*duplicate() = 0;

		virtual int	equals(RCPacket *p) = 0;

		int		getPacketID();
		
		void		setPacketID(int newPacketID);

		RCPacket	*getNext();

		RCPacket	*getPrv();

		void		setNext(RCPacket *newNext);

		void		setPrv(RCPacket *newPrv);

};
