/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define INTEGRITY_ERROR	-1
#define NONE_FREE		PKTID_INVALID

class RCPacketStorage
{
	private:
		int		iFree;
		int		size;
		RCPacket	**array;
		int		packets;

	public:
		/*
		 * Size is the number of entries in the cache,
		 * not the number of packets.
		 */
		RCPacketStorage(int arraySize);
		
		~RCPacketStorage();
		
		/*
		 * This returns a free index, 0 <= i < size,
		 * or NONE_FREE when all is full;
		 */
		int		findFreeIndex();
		
		RCPacket	*packetList(int pktID);
		
		/*
		 * Returns true on success
		 */
		int		storePacket(RCPacket *p);
		
		/*
		 * Returns true on success
		 */
		int		deletePacket(RCPacket *p);
		
		/*
		 * Returns the number of packets stored
		 */
		int		getPackets();
		
		int		deleteByPacketID(int pIndex);

		/*
		  * integrity Checks return the number of packet or INTEGRITY_ERROR
		  */
		int		integrityCheckByPacketID(int pIndex);

		int		integrityCheck();
};
