/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <time.h>
#include "DBElement.h"
#include "RCParameters.h"

RCParameters::RCParameters(int newPatternID, int newTargetConnectionID,
				int newSearchTTL, time_t newInitTime)
{
	patternID		= newPatternID;
	targetConnectionID      = newTargetConnectionID;
	searchTTL		= newSearchTTL;
	initTime		= newInitTime;
}

int RCParameters::getPatternID()
{
	return patternID;
}

int RCParameters::getTargetConnectionID()
{
	return targetConnectionID;
}

int RCParameters::getSearchTTL()
{
	return searchTTL;
}

time_t RCParameters::getInitTime()
{
	return initTime;
}

void RCParameters::setSearchTTL(int newSearchTTL)
{
	searchTTL	= newSearchTTL;
}

void RCParameters::setInitTime(time_t newInitTime)
{
	initTime	= newInitTime;
}

int RCParameters::equals(DBElement *other)
{
	return ((patternID == ((RCParameters *)other)->getPatternID())		&&
		(targetConnectionID == ((RCParameters *)other)->getTargetConnectionID())	);
}

int RCParameters::lessThan(DBElement *other)
{
	if (patternID < ((RCParameters *)other)->getPatternID())
		return 1;
		
	if (patternID > ((RCParameters *)other)->getPatternID())
		return 0;
		
	if (targetConnectionID < ((RCParameters *)other)->getTargetConnectionID())
		return 1;
	
	return 0;
}

int RCParameters::greaterThan(DBElement *other)
{
	if (patternID > ((RCParameters *)other)->getPatternID())
		return 1;
		
	if (patternID < ((RCParameters *)other)->getPatternID())
		return 0;
		
	if (targetConnectionID > ((RCParameters *)other)->getTargetConnectionID())
		return 1;
	
	return 0;
}

unsigned int RCParameters::hashValue()
{
	return patternID + targetConnectionID;
}


