/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

class RCParameters : public DBElement
{
	private:
		int	patternID;
		int	targetConnectionID;
		int	searchTTL;
		time_t	initTime;

	public:
		RCParameters(int newPatternID, int newTargetConnectionID,
				int newSearchTTL, time_t newInitTime);
 
		int	getPatternID();

		int	getTargetConnectionID();

		int	getSearchTTL();

		time_t	getInitTime();

		void	setSearchTTL(int newSearchTTL);

		void	setInitTime(time_t newInitTime);

                /*
                 * DBElement inheritance
                 */
                int             equals(DBElement *other);
 
                int             lessThan(DBElement *other);
 
                int             greaterThan(DBElement *other);
 
                unsigned int    hashValue();
};
