/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define MAX_QUERY_SIZE	256

#define RCPATTERN_REFLIST_MESGID	0
#define RCPATTERN_REFLIST_PARAMETERS	1
#define RCPATTERN_REFLIST_ENTRY		2
#define RCPATTERN_REFLIST_SPAM		3

#define RCPATTERN_REFARRAY_SIZE		4

class RCPattern : public DBElement
{
	private:
		char		pattern[MAX_QUERY_SIZE];
		/*
		 * Refcount counts how many RCEntries refer to it.
		 */
		int		refCount;
		RCRefList       *refListArray[RCPATTERN_REFARRAY_SIZE];
		
	public:
		RCPattern(char *newPattern);

		~RCPattern();
		
		void		setPattern(char *newPattern);

		void		getPattern(char *buf);

		int		incRefCount();

		int		decRefCount();

		int		getRefCount();
		
		int		addToRefList(int whichList, RCRefList *reference);
		
		int		deleteFromRefList(int whichList, int index);
		
		RCRefList	*getRefList(int whichList);

		/*
		 * Fast Access
		 */
		char		*getPatternp();

		/*
		 * DBElement inheritance
		 */
                int		equals(DBElement *other);
 
                int     	lessThan(DBElement *other);
 
                int    	 	greaterThan(DBElement *other);
 
                unsigned int    hashValue();
};
