/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * Maximum number of times a query from one connection is treated seriously
 * before it is considered spam.
 */
#define MAX_QUERY_BEFORE_SPAM				50

class RCQCache : public RCCache
{
	private:
		DB		*RCPatternDB;
		DB		*RCMesgIDDB;
		DB		*RCParametersDB;
		DB		*RCEntryDB;
		DB		*RCSpamDB;

		/*
		 * local functions
		 */
   		int		checkForSpam(int pIndex, int sConID);
   		int		removeByPatternID(int pIndex);
		int		addQuery(RCQPacket *p, RCPattern *pat);
		int		handleCacheMissOnConnection(RCQPacket *p, RCParameters *rcpar,
						RCPattern *pat, int conID);
		int 		handleCacheHitOnConnection(RCQPacket *p, RCPattern *pat, int pIndex, int conID);
		int		handleCacheHitInitTimeOnConnection(RCQPacket *p, RCMesgID *rcmid, RCPattern *pat);
		int		checkIntegrity();

	public:
		RCQCache(int newSize, int newMaxConnections);
		
		~RCQCache();

		int		handleResponsePacket(RCPacket *p);

		int 		handleQueryPacket(RCPacket *p);

		int		unRegisterConnectionID(int cIndex);

		int		flush();
};   		          
