/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <time.h>

#include "YourPacket.h"
#include "RCPacket.h"
#include "RCQRPacket.h"

RCQRPacket::RCQRPacket(void *newPacket) : RCPacket(newPacket)
{
	flushTime	= time(0) + this->getSTL();
}

RCQRPacket::~RCQRPacket()
{
	if (packet)
		delete (PACKET_TYPE *)packet;
}

time_t RCQRPacket::getFlushTime()
{
	return flushTime;
}

unsigned short RCQRPacket::getSTL()
{
	return ((PACKET_TYPE *)packet)->getSTL();
}

void RCQRPacket::setMesgID(char *mid)
{
	((PACKET_TYPE *)packet)->setMesgID(mid);
}

void RCQRPacket::getClientID(char *cid)
{
	((PACKET_TYPE *)packet)->getClientID(cid);
}

int RCQRPacket::setSTL(unsigned short newSTL)
{
	return ((PACKET_TYPE *)packet)->setSTL(newSTL);
}

RCPacket *RCQRPacket::duplicate()
{
	RCQRPacket	*dup;
	
	dup	= new RCQRPacket((void *)((PACKET_TYPE *)packet)->duplicate());
	dup->setSTL(this->getSTL());
	
	return dup;
}

int RCQRPacket::equals(RCPacket *p)
{
	char	cid[16];
	char	pcid[16];
	int	i;
	
	if (this->getType() != p->getType())
		return 0;

	this->getClientID(cid);
	((RCQRPacket *)p)->getClientID(pcid);
	for (i = 0; i < 16; i++)
		if (cid[i] != pcid[i])
			return 0;

	return 1;
}

