/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "DBElement.h"
#include "RCSpam.h"

RCSpam::RCSpam(int newPatternID, int newSourceConnectionID)
{
	patternID		= newPatternID;
	sourceConnectionID	= newSourceConnectionID;
	counter			= 0;
}

int RCSpam::getPatternID()
{
	return patternID;
}

int RCSpam::getSourceConnectionID()
{
	return sourceConnectionID;
}

int RCSpam::getCounter()
{
	return counter;
}
		
int RCSpam::incCounter()
{
	return ++counter;
}
		
int RCSpam::equals(DBElement *other)
{
	return ( (patternID == ((RCSpam *)other)->getPatternID())	&&
		(sourceConnectionID == ((RCSpam *)other)->getSourceConnectionID()) );
}
 
int RCSpam::lessThan(DBElement *other)
{
	if (patternID < ((RCSpam *)other)->getPatternID())
		return 1;
	if (patternID > ((RCSpam *)other)->getPatternID())
		return 0;
		
	if (sourceConnectionID < ((RCSpam *)other)->getSourceConnectionID())
		return 1;
		
	return 0;
}
 
int RCSpam::greaterThan(DBElement *other)
{
	if (patternID > ((RCSpam *)other)->getPatternID())
		return 1;
	if (patternID < ((RCSpam *)other)->getPatternID())
		return 0;
		
	if (sourceConnectionID > ((RCSpam *)other)->getSourceConnectionID())
		return 1;
		
	return 0;
}
 
unsigned int RCSpam::hashValue()
{
	return patternID * sourceConnectionID + patternID;
}
