#include <string.h>
#include <stdlib.h>
#include "Constants.h"
#include "DBElement.h"
#include "FSEntry.h"
#include "Path.h"
#include "File.h"
#include "SearchResult.h"

SearchResult::SearchResult(int hp, unsigned long int hip, int hs, int i,
				int sz, int ci, char *nm, char *gcid)
{
	hostPort	= hp;
	hostIP		= hip;
	hostSpeed	= hs;
	fileIndex	= i;
	size		= sz;
	connectionIndex	= ci;
	strncpy(name, nm, FILE_NAME_LENGTH);
	memcpy(GClientID, gcid, CLIENTID_LENGTH);
}

int SearchResult::getHostPort()
{
	return hostPort;
}

unsigned long int SearchResult::getHostIP()
{
	return hostIP;
}

int SearchResult::getHostSpeed()
{
	return hostSpeed;
}

int SearchResult::getFileIndex()
{
	return fileIndex;
}

int SearchResult::getSize()
{
	return size;
}

int SearchResult::getConnectionIndex()
{
	return connectionIndex;
}

void SearchResult::getName(char *buf)
{
	strcpy(buf, name);
}

void SearchResult::getGClientID(char *buf)
{
	memcpy(buf, GClientID, CLIENTID_LENGTH);
}

/*
 * DBElement Inheritance
 */

int SearchResult::equals(DBElement *sr)
{
	if 	(
		(hostPort	!= ((SearchResult *)sr)->getHostPort())	||
		(hostIP		!= ((SearchResult *)sr)->getHostIP())	||
		(hostSpeed	!= ((SearchResult *)sr)->getHostSpeed())
		)
		return 0;

	return (!strncmp(((SearchResult *)sr)->getNamep(), name, FILE_NAME_LENGTH));
}

int SearchResult::lessThan(DBElement *sr)
{
	if (hostPort < ((SearchResult *)sr)->getHostPort())
		return 1;
	if (hostPort > ((SearchResult *)sr)->getHostPort())
		return 0;

	if (hostIP < ((SearchResult *)sr)->getHostIP())
		return 1;
	if (hostIP > ((SearchResult *)sr)->getHostIP())
		return 0;

	if (hostSpeed < ((SearchResult *)sr)->getHostSpeed())
		return 1;
	if (hostSpeed > ((SearchResult *)sr)->getHostSpeed())
		return 0;

	return (strncmp(name, ((SearchResult *)sr)->getNamep(), FILE_NAME_LENGTH)
								< 0);
}

int SearchResult::greaterThan(DBElement *sr)
{
	if (hostPort > ((SearchResult *)sr)->getHostPort())
		return 1;
	if (hostPort < ((SearchResult *)sr)->getHostPort())
		return 0;

	if (hostIP > ((SearchResult *)sr)->getHostIP())
		return 1;
	if (hostIP < ((SearchResult *)sr)->getHostIP())
		return 0;

	if (hostSpeed > ((SearchResult *)sr)->getHostSpeed())
		return 1;
	if (hostSpeed < ((SearchResult *)sr)->getHostSpeed())
		return 0;

	return (!strncmp(name, ((SearchResult *)sr)->getNamep(), FILE_NAME_LENGTH)
								> 0);
}

unsigned int SearchResult::hashValue()
{
	return (*(unsigned int *)GClientID) + (*(unsigned int *)(GClientID + 4));
}

/*
 * FAME
 */

char *SearchResult::getNamep()
{
	return (char *)name;
}

char *SearchResult::getGClientIDp()
{
	return (char *)GClientID;
}
