/***************************************************************************
 *                                                                         *     
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/    

class SearchResult : public DBElement
{
	protected:
		int			hostPort;
		unsigned long int	hostIP; // In NETWORK order
		int			hostSpeed;
		int			fileIndex;
		int			size;
		int			connectionIndex;
		char			name[FILE_NAME_LENGTH];
		char			GClientID[CLIENTID_LENGTH];

	public :
		SearchResult(int hp, unsigned long int hip, int hs, int fi,
					int sz, int ci,char *nm, char *gcid);

		int 		getHostPort();

		unsigned long int getHostIP();

		int 		getHostSpeed();

		int 		getFileIndex();

		int 		getSize();

		int		getConnectionIndex();

		void		getName(char *buf);

		void 		getGClientID(char *buf);

		/*
		 * FAME
		 */

		char		*getNamep();

		char		*getGClientIDp();

		/*
		 * DBElement inheritance
		 */

                int 		equals(DBElement *sr);

                int 		lessThan(DBElement *sr);

                int 		greaterThan(DBElement *sr);

                unsigned int	hashValue();
};
