/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define TRANSFER_FN_LENGTH	256
#define LOCAL_WRITE	0
#define LOCAL_READ	1

class Transfer : public Connection
{
	protected:
		int		fileID;
		int		bytesLeft;
		int		bytesDone;
		int		bytesTotal;
		char		fileName[TRANSFER_FN_LENGTH];
		char		dirName[TRANSFER_FN_LENGTH];
		FILE		*file;
		unsigned int	offset;
		
	public	:
		Transfer();

		Transfer(int newFileID, char *newFileName, char *newDirName,
				int newOffset, Connection *c);
				
		Transfer(int newFileID, char *newFileName, char *newDirName,
				int newOffset);
				
		~Transfer();


		virtual int	loginToPeer() { return 0;}

		/*
		 * Start return values :
		 * 1	: OK
		 * -1	: open (read) failed
		 * -2	: open (write) failed
		 * -3	: seek failed
		 */
		int		Start(int ro);
	
		int		getOffset();

		int		getFileID();

		void 		getFileName(char *buf);

		void 		getDirName(char *buf);

		int		getBytesLeft();

		int		getBytesDone();

		int		getBytesTotal();

		/*
		 * FAME
		 */

		char		*getFileNamep();

		char		*getDirNamep();
};
